#define SAVE_SCREEN
#include "editor.h"

keyboard_handler input_state;

static void CALLBACK cleanup(void);
//{{{
void _main(void)
{
	int input;
	
	initialize();
	
	while(1) {
		input = read_char();
		input_state(input);
	}
}
//}}}
short saved_between_delay, saved_init_delay;
//{{{
void initialize(void)
{
	saved_init_delay = OSInitKeyInitDelay( 250 );
	saved_between_delay = OSInitBetweenKeyDelay( 70 );
	
	clrscr();
	GrayOn();
	atexit(cleanup);
	
	initialize_editor();
	default_map();
	
	enter_edit_state();
}
//}}}
//{{{
static void CALLBACK cleanup(void)
{
	OSInitKeyInitDelay(saved_init_delay);
	OSInitBetweenKeyDelay(saved_between_delay);
	set_num_maps(0);
	if(maps)
		free(maps);
	GrayOff();
}
//}}}

